Dans cette version de l'application la majorité des fonctionnalités de l'application sont implementé en utilisant Electron. 
Plusieurs fois le mot `CtrlOrCmd` apparait dans cette note pour définir les raccourcis clavier.
 Quand ce mot est présent cela signifie que le raccourcis sur Linux et Windows utilise la touche Ctrl plus une autre 
 alors que sur Mac on utilisara la touche Cmd en plus de l'autre.

#### Menu d'application

L'application possède un menu d'application (souvent situé en haut de l'application) possède 4 sous-menus :

- **Fichier** : Gestion des notes
    - ***Nouveau*** *(CtrlOrCmd+N)* : Ouvre la fenêtre de création d'une nouvelle note
    - ***Importer*** *(CtrlOrCmd+I)* : Importe une note à partir d'un fichier. Plus d'informations dans `Export / Import`
    - ***Reset*** *(CtrlOrCmd+R)* : Remet l'application dans son état d'origine avant toutes modifications
- **Démo** : Démonstration posibilités d'Electron
    - ***Calcul nombre premier*** : Permet de calculer si un nombre donné est premier. 
    Le but est de montré qu'Electron est capable de faire des calculs en arrière plan sans impacter le reste de l'application. 
    Pour que le calcul ne soit pas trop rapide il faut renseigner un nombre vers les 10 milliards
    - ***Reduire l'application*** : Ferme la fenêtre et met l'application dans la barre des tâches. 
    Pour réouvrir l'application il suffit de cliquer sur l'icone
- **Fenêtre** : Gestion de la fenêtre
    - ***Pleine écran*** *(F11)*
    - ***Minimiser*** *(CtrlOrCmd+M)*
    - ***Fermer*** *(CtrlOrCmd+W)*
    - ***Outils Développeur*** *(CtrlOrCmd+Maj+I)* : Ouvre la console de développement de Chromium
- **À propos** : Infos et version de l'application
    - ***Electron*** : Ouvre le site d'Electron dans le navigateur
    - ***Electronotes*** : Ouvre le git d'Electronotes (cette application) dans le navigateur
    - ***Versions*** : Indique les versions d'Electron, de Node et de Chromium utilisées par l'application

#### Menu contextuel

Le menu contextuel s'affiche en faisant clic droit dans l'application. Il propose plusieurs actions :

- **Nouveau** : Ouvre la fenêtre de création d'une nouvelle note
- **Importer** : Importe une note à partir d'un fichier. Plus d'informations dans `Export / Import`
- **Exporter en markdown** : Si coché les fichier exporté seront en markdown et non json. Plus d'informations dans `Export / Import`
- **Afficher chargement** : Affiche/Cache l'écran de chargement
- **Outils Développeur** : Ouvre la console de développement de Chromium

#### Export / Import

Il est possible d'importer et d'exporter des notes sous deux format, en markdown et en JSON.
Quand l'export est fait en markdown un le titre de la note devient le nom du fichier et le contenue est le même.
Dans le cas de l'export en JSON un fichier avec le format ci-dessous seras généré :

```json
{
    "id": "id unique de la note dans l'application",
    "title": "titre de la note",
    "content": "contenue de la note en markdown"
}
```

C'est ce type de fichier qui est utilisé pour importer les notes par défaut de l'application.
C'est aussi sous cette forme que sont stocker les données dans l'application.

Pour le choix du type d'export ce fait dans le menu contextuel, par défaut l'export ce fait en markdown. Pour exporter une note il suffit de faire un cliquez-doposez d'une note de l'application vers un gestionnaire de fichier.

---

Il est possible d'importer les deux types de fichier de l'export. Pour importer il suffit de selectionner l'option dans le menu d'application (Fichier > Importer), dans le menu contextuel ou de faire le raccourcis CtrlOrCmd+I.

Lors de l'import d'un fichier en markdown le nom du fichier devient le titre de la note et le contenue du fichier devient celui de la note.
Un id est généré automatiquement lors de la création du JSON correspond à la note pour le sotckage.

Pour l'import d'un fichier JSON celui-ci doit resepecter la structure décrite au-dessus. 
De plus l'id ne doit pas être déjà utilisé par une autre note, sinon un message d'erreur est retourné.
Le JSON est utilisé tel quel pour stocker et afficher la note.